/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of Certificate.xs. Do not edit this file, edit Certificate.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Certificate.xs"
#include "module.h"

struct cb_data {
	SV *cb;
	SV *user_data;
};

static void cb_cert_verify(PurpleCertificateVerificationStatus st, struct cb_data *d) {
	dSP;

	ENTER;
	SAVETMPS;

	PUSHMARK(SP);

	XPUSHs(sv_2mortal(newSViv(st)));
	XPUSHs(d->user_data);

	PUTBACK;

	call_sv(d->cb, G_VOID | G_EVAL);

	if(SvTRUE(ERRSV)) {
		STRLEN l_a;
		purple_debug_warning("perl", "Failed to run 'certificate verify' callback: %s\n", SvPV(ERRSV, l_a));
	}

	FREETMPS;
	LEAVE;

	SvREFCNT_dec(d->cb);
	SvREFCNT_dec(d->user_data);

	g_free(d);
}

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 51 "Certificate.c"

XS(XS_Purple__Certificate_add_ca_search_path); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_add_ca_search_path)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::add_ca_search_path", "path");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char*	path = (const char *)SvPV_nolen(ST(0));

	purple_certificate_add_ca_search_path(path);
    }
    XSRETURN_EMPTY;
}


XS(XS_Purple__Certificate_check_subject_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_check_subject_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::check_subject_name", "crt, name");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate	crt = purple_perl_ref_object(ST(0));
	const gchar*	name = (const gchar *)SvPV_nolen(ST(1));
	gboolean	RETVAL;

	RETVAL = purple_certificate_check_subject_name(crt, name);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_copy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_copy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::copy", "crt");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate	crt = purple_perl_ref_object(ST(0));
	Purple__Certificate	RETVAL;

	RETVAL = purple_certificate_copy(crt);
	ST(0) = purple_perl_bless_object(RETVAL, "Purple::Certificate");

	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::destroy", "crt");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate	crt = purple_perl_ref_object(ST(0));

	purple_certificate_destroy(crt);
    }
    XSRETURN_EMPTY;
}


XS(XS_Purple__Certificate_display_x509); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_display_x509)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::display_x509", "crt");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate	crt = purple_perl_ref_object(ST(0));

	purple_certificate_display_x509(crt);
    }
    XSRETURN_EMPTY;
}


XS(XS_Purple__Certificate_export); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_export)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::export", "crt, filename");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const gchar*	filename = (const gchar *)SvPV_nolen(ST(1));
	Purple__Certificate	crt = purple_perl_ref_object(ST(0));
	gboolean	RETVAL;

	RETVAL = purple_certificate_export(filename, crt);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_find_pool); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_find_pool)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::find_pool", "scheme_name, pool_name");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const gchar*	scheme_name = (const gchar *)SvPV_nolen(ST(0));
	const gchar*	pool_name = (const gchar *)SvPV_nolen(ST(1));
	Purple__Certificate__Pool	RETVAL;

	RETVAL = purple_certificate_find_pool(scheme_name, pool_name);
	ST(0) = purple_perl_bless_object(RETVAL, "Purple::Certificate::Pool");

	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_find_scheme); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_find_scheme)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::find_scheme", "name");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const gchar*	name = (const gchar *)SvPV_nolen(ST(0));
	Purple__Certificate__Scheme	RETVAL;

	RETVAL = purple_certificate_find_scheme(name);
	ST(0) = purple_perl_bless_object(RETVAL, "Purple::Certificate::Scheme");

	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_find_verifier); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_find_verifier)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::find_verifier", "scheme_name, ver_name");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const gchar*	scheme_name = (const gchar *)SvPV_nolen(ST(0));
	const gchar*	ver_name = (const gchar *)SvPV_nolen(ST(1));
	Purple__Certificate__Verifier	RETVAL;

	RETVAL = purple_certificate_find_verifier(scheme_name, ver_name);
	ST(0) = purple_perl_bless_object(RETVAL, "Purple::Certificate::Verifier");

	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_get_handle); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_get_handle)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::get_handle", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Handle	RETVAL;

	RETVAL = purple_certificate_get_handle();
	ST(0) = purple_perl_bless_object(RETVAL, "Purple::Handle");

	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_get_issuer_unique_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_get_issuer_unique_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::get_issuer_unique_id", "crt");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate	crt = purple_perl_ref_object(ST(0));
	gchar_own *	RETVAL;

	RETVAL = purple_certificate_get_issuer_unique_id(crt);
	ST(0) = sv_newmortal();
	/* used when we can directly own the returned string. */
	/* we have to copy in the case when perl's malloc != gtk's malloc,
	 * so best copy all the time. */
	sv_setpv ((SV*)ST(0), RETVAL);
	SvUTF8_on (ST(0));
	g_free (RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_get_subject_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_get_subject_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::get_subject_name", "crt");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate	crt = purple_perl_ref_object(ST(0));
	gchar_own *	RETVAL;

	RETVAL = purple_certificate_get_subject_name(crt);
	ST(0) = sv_newmortal();
	/* used when we can directly own the returned string. */
	/* we have to copy in the case when perl's malloc != gtk's malloc,
	 * so best copy all the time. */
	sv_setpv ((SV*)ST(0), RETVAL);
	SvUTF8_on (ST(0));
	g_free (RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_get_unique_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_get_unique_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::get_unique_id", "crt");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate	crt = purple_perl_ref_object(ST(0));
	gchar_own *	RETVAL;

	RETVAL = purple_certificate_get_unique_id(crt);
	ST(0) = sv_newmortal();
	/* used when we can directly own the returned string. */
	/* we have to copy in the case when perl's malloc != gtk's malloc,
	 * so best copy all the time. */
	sv_setpv ((SV*)ST(0), RETVAL);
	SvUTF8_on (ST(0));
	g_free (RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_import); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_import)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::import", "scheme, filename");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate__Scheme	scheme = purple_perl_ref_object(ST(0));
	const gchar*	filename = (const gchar *)SvPV_nolen(ST(1));
	Purple__Certificate	RETVAL;

	RETVAL = purple_certificate_import(scheme, filename);
	ST(0) = purple_perl_bless_object(RETVAL, "Purple::Certificate");

	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_register_pool); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_register_pool)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::register_pool", "pool");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate__Pool	pool = purple_perl_ref_object(ST(0));
	gboolean	RETVAL;

	RETVAL = purple_certificate_register_pool(pool);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_register_scheme); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_register_scheme)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::register_scheme", "scheme");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate__Scheme	scheme = purple_perl_ref_object(ST(0));
	gboolean	RETVAL;

	RETVAL = purple_certificate_register_scheme(scheme);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_register_verifier); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_register_verifier)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::register_verifier", "vr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate__Verifier	vr = purple_perl_ref_object(ST(0));
	gboolean	RETVAL;

	RETVAL = purple_certificate_register_verifier(vr);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_signed_by); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_signed_by)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::signed_by", "crt, issuer");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate	crt = purple_perl_ref_object(ST(0));
	Purple__Certificate	issuer = purple_perl_ref_object(ST(1));
	gboolean	RETVAL;

	RETVAL = purple_certificate_signed_by(crt, issuer);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_unregister_pool); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_unregister_pool)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::unregister_pool", "pool");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate__Pool	pool = purple_perl_ref_object(ST(0));
	gboolean	RETVAL;

	RETVAL = purple_certificate_unregister_pool(pool);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_unregister_scheme); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_unregister_scheme)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::unregister_scheme", "scheme");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate__Scheme	scheme = purple_perl_ref_object(ST(0));
	gboolean	RETVAL;

	RETVAL = purple_certificate_unregister_scheme(scheme);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_unregister_verifier); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_unregister_verifier)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::unregister_verifier", "vr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate__Verifier	vr = purple_perl_ref_object(ST(0));
	gboolean	RETVAL;

	RETVAL = purple_certificate_unregister_verifier(vr);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_verify_complete); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_verify_complete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::verify_complete", "vrq, st");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate__VerificationRequest	vrq = purple_perl_ref_object(ST(0));
	Purple__Certificate__VerificationStatus	st = (Purple__Certificate__VerificationStatus)SvIV(ST(1));

	purple_certificate_verify_complete(vrq, st);
    }
    XSRETURN_EMPTY;
}


XS(XS_Purple__Certificate_get_times); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_get_times)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::get_times", "crt");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate	crt = purple_perl_ref_object(ST(0));
	gboolean	RETVAL;
	time_t	activation;
	time_t	expiration;

	RETVAL = purple_certificate_get_times(crt, &activation, &expiration);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
	XSprePUSH;	EXTEND(SP,2);
	PUSHs(sv_newmortal());
	sv_setiv(ST(1), (IV)activation);
	PUSHs(sv_newmortal());
	sv_setiv(ST(2), (IV)expiration);
    }
    XSRETURN(3);
}


XS(XS_Purple__Certificate_destroy_list); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_destroy_list)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 159 "Certificate.xs"
	GList* l = NULL;
	int i = 0;
#line 620 "Certificate.c"
#line 162 "Certificate.xs"
		for(i = 0; i < items; i++) { /* PurpleCertificate */
			l = g_list_prepend(l, purple_perl_ref_object(ST(i)));
		}
		purple_certificate_destroy_list(l);
#line 626 "Certificate.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Purple__Certificate_get_pools); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_get_pools)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::get_pools", "");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 170 "Certificate.xs"
		GList *l;
#line 648 "Certificate.c"
#line 172 "Certificate.xs"
		for(l = purple_certificate_get_pools(); l; l = l->next) {
			XPUSHs(sv_2mortal(purple_perl_bless_object(l->data, "Purple::Certificate::Pool")));
		}
#line 653 "Certificate.c"
	PUTBACK;
	return;
    }
}


XS(XS_Purple__Certificate_get_schemes); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_get_schemes)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::get_schemes", "");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 179 "Certificate.xs"
		GList *l;
#line 676 "Certificate.c"
#line 181 "Certificate.xs"
		for(l = purple_certificate_get_schemes(); l; l = l->next) {
			XPUSHs(sv_2mortal(purple_perl_bless_object(l->data, "Purple::Certificate::Scheme")));
		}
#line 681 "Certificate.c"
	PUTBACK;
	return;
    }
}


XS(XS_Purple__Certificate_get_verifiers); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_get_verifiers)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::get_verifiers", "");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 188 "Certificate.xs"
		GList *l;
#line 704 "Certificate.c"
#line 190 "Certificate.xs"
		for(l = purple_certificate_get_verifiers(); l; l = l->next) {
			XPUSHs(sv_2mortal(purple_perl_bless_object(l->data, "Purple::Certificate::Verifier")));
		}
#line 709 "Certificate.c"
	PUTBACK;
	return;
    }
}


XS(XS_Purple__Certificate_check_signature_chain); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_check_signature_chain)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 197 "Certificate.xs"
		GList *l = NULL;
		gboolean ret;
		int i;
#line 732 "Certificate.c"
#line 201 "Certificate.xs"
		for(i = 0; i < items; i++) { /* PurpleCertificate */
			l = g_list_prepend(l, purple_perl_ref_object(ST(i)));
		}
		l = g_list_reverse(l);
		ret = purple_certificate_check_signature_chain(l);
		g_list_free(l);
		if(ret) XSRETURN_YES;
		XSRETURN_NO;
#line 742 "Certificate.c"
	PUTBACK;
	return;
    }
}


XS(XS_Purple__Certificate_get_fingerprint_sha1); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_get_fingerprint_sha1)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::get_fingerprint_sha1", "crt");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate	crt = purple_perl_ref_object(ST(0));
#line 214 "Certificate.xs"
		GByteArray *gba = NULL;
#line 764 "Certificate.c"
	SV *	RETVAL;
#line 216 "Certificate.xs"
		gba = purple_certificate_get_fingerprint_sha1(crt);
		RETVAL = newSVpv(gba->data, gba->len);
		g_byte_array_free(gba, TRUE);
#line 770 "Certificate.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate_verify); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate_verify)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::verify", "verifier, subject_name, cert_chain, cb, cb_data");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Purple__Certificate__Verifier	verifier = purple_perl_ref_object(ST(0));
	const gchar*	subject_name = (const gchar *)SvPV_nolen(ST(1));
	AV*	cert_chain;
	CV *	cb;
	SV *	cb_data = ST(4);
#line 230 "Certificate.xs"
		GList *l = NULL;
		int len = 0, i = 0;
		struct cb_data *d = NULL;
#line 801 "Certificate.c"

	if (SvROK(ST(2)) && SvTYPE(SvRV(ST(2)))==SVt_PVAV)
	    cert_chain = (AV*)SvRV(ST(2));
	else
	    Perl_croak(aTHX_ "%s: %s is not an array reference",
			"Purple::Certificate::verify",
			"cert_chain");

	if (SvROK(ST(3)) && SvTYPE(SvRV(ST(3)))==SVt_PVCV)
	    cb = (CV*)SvRV(ST(3));
	else
	    Perl_croak(aTHX_ "%s: %s is not a code reference",
			"Purple::Certificate::verify",
			"cb");
#line 234 "Certificate.xs"
		len = av_len(cert_chain) + 1;
		for(i = 0; i < len; i++) {
			SV **sv = av_fetch(cert_chain, i, 0);
			if(!sv || !purple_perl_is_ref_object(*sv)) {
				g_list_free(l);
				warn("Purple::Certificate::verify: cert_chain: non-purple object in array...");
				XSRETURN_UNDEF;
			}
			l = g_list_prepend(l, purple_perl_ref_object(*sv));
		}
		l = g_list_reverse(l);

		d = g_new0(struct cb_data, 1);
		d->cb = newSVsv(ST(3));
		d->user_data = newSVsv(cb_data);

		purple_certificate_verify(verifier, subject_name, l, (PurpleCertificateVerifiedCallback) cb_cert_verify, d);

		g_list_free(l);
#line 836 "Certificate.c"
	PUTBACK;
	return;
    }
}


XS(XS_Purple__Certificate__Pool_get_idlist); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate__Pool_get_idlist)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::Pool::get_idlist", "pool");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Purple__Certificate__Pool	pool = purple_perl_ref_object(ST(0));
#line 261 "Certificate.xs"
		GList *l, *b;
#line 860 "Certificate.c"
#line 263 "Certificate.xs"
		b = purple_certificate_pool_get_idlist(pool);
		for(l = b; l; l = l->next) {
			XPUSHs(sv_2mortal(newSVpv(l->data, 0)));
		}
		purple_certificate_pool_destroy_idlist(b);
#line 867 "Certificate.c"
	PUTBACK;
	return;
    }
}


XS(XS_Purple__Certificate__Pool_contains); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate__Pool_contains)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::Pool::contains", "pool, id");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate__Pool	pool = purple_perl_ref_object(ST(0));
	const gchar*	id = (const gchar *)SvPV_nolen(ST(1));
	gboolean	RETVAL;

	RETVAL = purple_certificate_pool_contains(pool, id);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate__Pool_delete); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate__Pool_delete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::Pool::delete", "pool, id");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate__Pool	pool = purple_perl_ref_object(ST(0));
	const gchar*	id = (const gchar *)SvPV_nolen(ST(1));
	gboolean	RETVAL;

	RETVAL = purple_certificate_pool_delete(pool, id);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate__Pool_get_scheme); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate__Pool_get_scheme)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::Pool::get_scheme", "pool");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate__Pool	pool = purple_perl_ref_object(ST(0));
	Purple__Certificate__Scheme	RETVAL;

	RETVAL = purple_certificate_pool_get_scheme(pool);
	ST(0) = purple_perl_bless_object(RETVAL, "Purple::Certificate::Scheme");

	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate__Pool_mkpath); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate__Pool_mkpath)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::Pool::mkpath", "pool, id");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate__Pool	pool = purple_perl_ref_object(ST(0));
	const gchar*	id = (const gchar *)SvPV_nolen(ST(1));
	gchar_own *	RETVAL;

	RETVAL = purple_certificate_pool_mkpath(pool, id);
	ST(0) = sv_newmortal();
	/* used when we can directly own the returned string. */
	/* we have to copy in the case when perl's malloc != gtk's malloc,
	 * so best copy all the time. */
	sv_setpv ((SV*)ST(0), RETVAL);
	SvUTF8_on (ST(0));
	g_free (RETVAL);

    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate__Pool_retrieve); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate__Pool_retrieve)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::Pool::retrieve", "pool, id");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate__Pool	pool = purple_perl_ref_object(ST(0));
	const gchar*	id = (const gchar *)SvPV_nolen(ST(1));
	Purple__Certificate	RETVAL;

	RETVAL = purple_certificate_pool_retrieve(pool, id);
	ST(0) = purple_perl_bless_object(RETVAL, "Purple::Certificate");

	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate__Pool_store); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate__Pool_store)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::Pool::store", "pool, id, crt");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate__Pool	pool = purple_perl_ref_object(ST(0));
	const gchar*	id = (const gchar *)SvPV_nolen(ST(1));
	Purple__Certificate	crt = purple_perl_ref_object(ST(2));
	gboolean	RETVAL;

	RETVAL = purple_certificate_pool_store(pool, id, crt);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Purple__Certificate__Pool_usable); /* prototype to pass -Wmissing-prototypes */
XS(XS_Purple__Certificate__Pool_usable)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Purple::Certificate::Pool::usable", "pool");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	Purple__Certificate__Pool	pool = purple_perl_ref_object(ST(0));
	gboolean	RETVAL;

	RETVAL = purple_certificate_pool_usable(pool);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Purple__Certificate); /* prototype to pass -Wmissing-prototypes */
XS(boot_Purple__Certificate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXSproto("Purple::Certificate::add_ca_search_path", XS_Purple__Certificate_add_ca_search_path, file, "$");
        newXSproto("Purple::Certificate::check_subject_name", XS_Purple__Certificate_check_subject_name, file, "$$");
        newXSproto("Purple::Certificate::copy", XS_Purple__Certificate_copy, file, "$");
        newXSproto("Purple::Certificate::destroy", XS_Purple__Certificate_destroy, file, "$");
        newXSproto("Purple::Certificate::display_x509", XS_Purple__Certificate_display_x509, file, "$");
        newXSproto("Purple::Certificate::export", XS_Purple__Certificate_export, file, "$$");
        newXSproto("Purple::Certificate::find_pool", XS_Purple__Certificate_find_pool, file, "$$");
        newXSproto("Purple::Certificate::find_scheme", XS_Purple__Certificate_find_scheme, file, "$");
        newXSproto("Purple::Certificate::find_verifier", XS_Purple__Certificate_find_verifier, file, "$$");
        newXSproto("Purple::Certificate::get_handle", XS_Purple__Certificate_get_handle, file, "");
        newXSproto("Purple::Certificate::get_issuer_unique_id", XS_Purple__Certificate_get_issuer_unique_id, file, "$");
        newXSproto("Purple::Certificate::get_subject_name", XS_Purple__Certificate_get_subject_name, file, "$");
        newXSproto("Purple::Certificate::get_unique_id", XS_Purple__Certificate_get_unique_id, file, "$");
        newXSproto("Purple::Certificate::import", XS_Purple__Certificate_import, file, "$$");
        newXSproto("Purple::Certificate::register_pool", XS_Purple__Certificate_register_pool, file, "$");
        newXSproto("Purple::Certificate::register_scheme", XS_Purple__Certificate_register_scheme, file, "$");
        newXSproto("Purple::Certificate::register_verifier", XS_Purple__Certificate_register_verifier, file, "$");
        newXSproto("Purple::Certificate::signed_by", XS_Purple__Certificate_signed_by, file, "$$");
        newXSproto("Purple::Certificate::unregister_pool", XS_Purple__Certificate_unregister_pool, file, "$");
        newXSproto("Purple::Certificate::unregister_scheme", XS_Purple__Certificate_unregister_scheme, file, "$");
        newXSproto("Purple::Certificate::unregister_verifier", XS_Purple__Certificate_unregister_verifier, file, "$");
        newXSproto("Purple::Certificate::verify_complete", XS_Purple__Certificate_verify_complete, file, "$$");
        newXSproto("Purple::Certificate::get_times", XS_Purple__Certificate_get_times, file, "$");
        newXSproto("Purple::Certificate::destroy_list", XS_Purple__Certificate_destroy_list, file, ";@");
        newXSproto("Purple::Certificate::get_pools", XS_Purple__Certificate_get_pools, file, "");
        newXSproto("Purple::Certificate::get_schemes", XS_Purple__Certificate_get_schemes, file, "");
        newXSproto("Purple::Certificate::get_verifiers", XS_Purple__Certificate_get_verifiers, file, "");
        newXSproto("Purple::Certificate::check_signature_chain", XS_Purple__Certificate_check_signature_chain, file, ";@");
        newXSproto("Purple::Certificate::get_fingerprint_sha1", XS_Purple__Certificate_get_fingerprint_sha1, file, "$");
        newXSproto("Purple::Certificate::verify", XS_Purple__Certificate_verify, file, "$$$$$");
        newXSproto("Purple::Certificate::Pool::get_idlist", XS_Purple__Certificate__Pool_get_idlist, file, "$");
        newXSproto("Purple::Certificate::Pool::contains", XS_Purple__Certificate__Pool_contains, file, "$$");
        newXSproto("Purple::Certificate::Pool::delete", XS_Purple__Certificate__Pool_delete, file, "$$");
        newXSproto("Purple::Certificate::Pool::get_scheme", XS_Purple__Certificate__Pool_get_scheme, file, "$");
        newXSproto("Purple::Certificate::Pool::mkpath", XS_Purple__Certificate__Pool_mkpath, file, "$$");
        newXSproto("Purple::Certificate::Pool::retrieve", XS_Purple__Certificate__Pool_retrieve, file, "$$");
        newXSproto("Purple::Certificate::Pool::store", XS_Purple__Certificate__Pool_store, file, "$$$");
        newXSproto("Purple::Certificate::Pool::usable", XS_Purple__Certificate__Pool_usable, file, "$");

    /* Initialisation Section */

#line 41 "Certificate.xs"
{
	HV *stash = gv_stashpv("Purple::Certificate", 1);

	static const constiv *civ, const_iv[] = {
#define const_iv(name) {#name, (IV)PURPLE_CERTIFICATE_##name}
		const_iv(INVALID),
		const_iv(VALID),
	};

	for (civ = const_iv + sizeof(const_iv) / sizeof(const_iv[0]); civ-- > const_iv; )
		newCONSTSUB(stash, (char *)civ->name, newSViv(civ->iv));
}

#line 1120 "Certificate.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

